################################################################################
##
## Copyright (c) 2005 Xilinx, Inc. All Rights Reserved.
## You may copy and modify these files for your own internal use solely with
## Xilinx programmable logic devices and Xilinx EDK system or create IP
## modules solely for Xilinx programmable logic devices and Xilinx EDK system.
## No rights are granted to distribute any files unless they are distributed in
## Xilinx programmable logic devices.
##
## opb_mdm_v2_1_0.tcl
##
################################################################################

proc check_iplevel_settings {mhsinst} {
   # Return value
   set retval 0
   # FSL fast download connection made
   set fsl_fast_con 0

   # C_WRITE_FSL_PORTS set
   set fsl_write_ports [xget_hw_parameter_value $mhsinst "C_WRITE_FSL_PORTS"]
   # puts "Write ports: $fsl_write_ports"

   # Get FSL bus handle
   set fsl_bus_handle [xget_handle $mhsinst "BUS_INTERFACE" "MFSL0"]

   set fsl_bus_name ""
   if {$fsl_bus_handle != ""} {
     # Name: MFSL0
     set fsl_bus_name [xget_value $fsl_bus_handle "VALUE"]

     if {$fsl_bus_name != ""} {
       # Connected to bus
       # puts "FSL BUS name: $fsl_bus_name"
       set fsl_fast_con 1
     }
   }

   if {($fsl_write_ports) && (! $fsl_fast_con)} {
     error "C_WRITE_FSL_PORTS is set, but the MFSL0 FSL interface is not connected." "" "mdt_error"
     set retval [expr $retval + 1]
   }

   if {(! $fsl_write_ports) && ($fsl_fast_con)} {
     error "The MFSL0 FSL interface is connected to \"$fsl_bus_name\", but C_WRITE_FSL_PORTS is not set." "" "mdt_error"
     set retval [expr $retval + 1]
   }

   return $retval
}

